{-----------------------------------------------------------------------}
{                                                                       }
{           Subprogram Name:                                            }
{           Purpose:          Ancestromania GPL                         }
{           Source Language:  Francais                                  }
{           Auteurs :                                                   }
{    Copyright Matthieu Giroux from 2013 to 2016 (LAZARUS),             }
{    Copyright André Langlet (2003 to 2013),                            }
{    Copyright Philippe Cazaux-Moutou (Old Ancestrologie 2003 GPL)      }
{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Description:                                                }
{           Ancestromania est un Logiciel Libre.                        }
{                                                                       }
{ This program is free software: you can redistribute it and/or modify  }
{ it under the terms of the GNU General Public License as published by  }
{ the Free Software Foundation, either version 3 of the License, or     }
{ (at your option) any later version.                                   }
{                                                                       }
{ This program is distributed in the hope that it will be useful,       }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of        }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         }
{ GNU General Public License for more details.                          }
{                                                                       }
{ You should have received a copy of the GNU General Public License     }
{ along with this program.  If not, see <http://www.gnu.org/licenses/>. }
{-----------------------------------------------------------------------}

{                                                                       }
{-----------------------------------------------------------------------}
{                                                                       }
{           Revision History                                            }
{           v#    ,Date       ,Author Name            ,Description      }
{                                                                       }
{-----------------------------------------------------------------------}

unit u_objet_TState;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  Classes;

type
  TState=class
  private
    fCount:integer;
    fStartValue:boolean;

    function GetValue:boolean;
    procedure SetValue(const Value:boolean);

  public
    constructor Create(StartValue:boolean); virtual;
    property Value:boolean read GetValue write SetValue;

  end;

implementation

{ TState }

constructor TState.Create(StartValue:boolean);
begin
  fCount:=0;
  fStartValue:=StartValue;
end;

function TState.GetValue:boolean;
begin
  if fCount=0 then
    result:=fStartValue
  else
    result:=not fStartValue;
end;

procedure TState.SetValue(const Value:boolean);
begin
  if Value=fStartValue then
  begin
    if fCount>0 then dec(fCount);
  end
  else
  begin
    inc(fCount);
  end;
end;

end.

